/**
 *
 */
package jp.agentec.sinaburocast.action.admin.support;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

import jp.agentec.sinaburocast.action.AbstractAction;
import jp.agentec.sinaburocast.action.admin.member.MemberSearchAction;
import jp.agentec.sinaburocast.common.util.SinaburoUtil;
import jp.agentec.sinaburocast.common.util.velocity.VelocityTool;
import jp.agentec.sinaburocast.form.admin.support.OrganizationSearchForm;
import jp.agentec.sinaburocast.service.OrganizationService;

import org.apache.log4j.Logger;
import org.apache.velocity.tools.generic.DateTool;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;
import org.seasar.struts.util.ResponseUtil;

/**
 * 団体検索
 * @author choi-c
 *
 */
public class OrganizationSearchAction extends AbstractAction {
	private final Logger logger = Logger.getLogger(getClass());
	
	@ActionForm
	public OrganizationSearchForm organizationSearchForm;
	
	
	public OrganizationService organizationService;  
	
	public MemberSearchAction memberSearchAction;
	/**
	 * 初期表示
	 */
	@Execute(validator = false,reset="resetIndex")
	public String index() {
		organizationSearchForm.searchResultList = organizationService.findAllByPaging(organizationSearchForm);
		
		//団体検索
		return "/admin/support/organizationSearch.html";
	}
	
	@Execute(validator = false,urlPattern="search/{pageNo}")
	public String search() {
		organizationSearchForm.searchResultList = organizationService.findAllByPaging(organizationSearchForm);
		
		//団体検索
		return "/admin/support/organizationSearch.html";
	}
	
	
	@Execute(validator = false)
	public String csvOutput() throws UnsupportedEncodingException, Exception {
		
		//String filePath = PropertyUtil.getProperty(SinaburoConstant.filePath.CSV_MAKE_FILE_PATH);
		String result = organizationService.getOrganizationForCsv(organizationSearchForm,memberSearchAction);
		result=SinaburoUtil.addDoubleStr(result);
		
		String dateStr = new DateTool().format("yyyyMMdd_HHmmss",DateTool.getSystemDate());
		
		//20170508 SJIS文字化け対応
		result = SinaburoUtil.toSJIS(result);
		ResponseUtil.download(URLEncoder.encode("支援ポイント集計結果_"+dateStr+".tsv", "UTF-8"),result.getBytes("Windows-31J") );
		//ResponseUtil.download(URLEncoder.encode("支援ポイント集計結果_"+dateStr+".tsv", "UTF-8"),result.getBytes("Shift_JIS") );
		
		//団体検索
		//return "/admin/support/organizationSearch.html";
		return null;
	}
	
	/**
	 * クリップボードを設定する。
	 */
	@Execute(validator = false)
	public String setClipboard(){
		VelocityTool.setClipboardString(organizationSearchForm.clipboard);
		return "/admin/support/organizationSearch.html";
	}

}
