package jp.agentec.sinaburocast.common.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * トレース出力を抑制するアノテーション
 * このアノテーションを付けると、TraceInterceptorがログ出力をスキップしてくれる。
 * 
 * @author tsukada
 *
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@Documented
public @interface SkipTrace {

}

