package jp.agentec.sinaburocast.service;

import javax.annotation.Resource;

import jp.agentec.sinaburocast.entity.Answer;
import junit.framework.TestSuite;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.seasar.dao.unit.S2DaoTestCase;

public class AnswerServiceTest extends S2DaoTestCase {

	@Resource
	private AnswerService answerService;

	public AnswerServiceTest(String string) {
		super(string);
	}

	public static TestSuite suite() {
		TestSuite suite = new TestSuite("AnswerServiceTest");
		suite.addTest(new AnswerServiceTest("findById"));
		suite.addTest(new AnswerServiceTest("insertAnswer"));
		suite.addTest(new AnswerServiceTest("findAllOrderById"));
		suite.addTest(new AnswerServiceTest("findAllByEnqueteId"));
		suite.addTest(new AnswerServiceTest("findAllByQuestionId"));
		suite.addTest(new AnswerServiceTest("deleteByEnqueteId"));
		suite.addTest(new AnswerServiceTest("findAllByEnqueteIdAndQuestionId"));
		suite.addTest(new AnswerServiceTest("findAllByAnswerId"));
		suite.addTest(new AnswerServiceTest("deleteByQuestionId"));
		suite.addTest(new AnswerServiceTest("recodeDeleteByQuestionId"));
		return suite;
	}


	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
        include("app.dicon");
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	public void findById() {
		System.out.println(answerService.findById(1));
	}

	public void insertAnswer() {
		Answer answer = new Answer();
		answer.answerNo = 1 ;
		answer.questionId = 1;
		answer.enqueteId = 1;

		System.out.println(answerService.insertAnswer(answer,"TESTCLASS01"));
	}

	public void findAllOrderById() {
		System.out.println(answerService.findAllOrderById());
	}

	public void findAllByEnqueteId() {
		System.out.println(answerService.findAllByEnqueteId("1"));
	}


	public void findAllByQuestionId() {
		System.out.println(answerService.findAllByQuestionId(1));
	}
	public void deleteByEnqueteId() {
		System.out.println(answerService.findAllByQuestionId(10000));
	}

	public void findAllByEnqueteIdAndQuestionId() {
		System.out.println(answerService.findAllByEnqueteIdAndQuestionId("1",10000));
	}

	public void findAllByAnswerId() {
		String [] ans = {"2","3"};
		System.out.println(answerService.findAllByAnswerId(ans));
	}

	public void deleteByQuestionId() {
		System.out.println(answerService.deleteByQuestionId(10000,"TESTCLASS01"));
	}

	public void recodeDeleteByQuestionId() {
		System.out.println(answerService.recodeDeleteByQuestionId(10000,"TESTCLASS01"));
	}
}
